=== src/cmd/syntool/CMakeLists.txt ===
# synergy -- mouse and keyboard sharing utility
# Copyright (C) 2014-2016 Symless Ltd.
# 
# This package is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# found in the file LICENSE that should have accompanied this file.
# 
# This package is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

file(GLOB headers "*.h")
file(GLOB sources "*.cpp")

include_directories(
	../
	../../lib/
)

if (UNIX)
	include_directories(
		../../..
	)
endif()

add_executable(syntool ${sources})
target_link_libraries(syntool
	synergy arch base client common io ipc mt net platform server ${libs} ${OPENSSL_LIBS})

if (CONF_CPACK)
	install(TARGETS
		syntool
		COMPONENT core
		DESTINATION bin)
endif()
