## synergy 1.8.8-stable+dfsg.1

=== debian/changelog ===
synergy (1.8.8-stable+dfsg.1-1build1) bionic; urgency=high

  * No change rebuild against openssl1.1.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 05 Feb 2018 23:28:59 +0000

synergy (1.8.8-stable+dfsg.1-1) unstable; urgency=low

  * New upstream version.
  * Added delete_temp_config.patch to enable deletion of qt_temp files.
    Closes: # 765955
  * Remove clipboardchunktests.patch (merged upstream)

 -- Joshua Honeycutt <joshua.honeycutt@gmail.com>  Sat, 11 Mar 2017 17:38:53 -0600
